import { ActionEnv, Dict } from "./interfaces";
export declare function defaultActionKit(ce: ActionEnv): {
    silently: {
        fail: (...args: any[]) => never;
        cp: (from: string, to: string) => Promise<void>;
        mv: (from: string, to: string) => Promise<void>;
        rm: (file: string) => Promise<void>;
        exists: (file: string) => Promise<boolean>;
        touch: (file: string) => Promise<void>;
        mkdir: (d: string) => Promise<void>;
        chmod: (file: string, mode: string | number) => Promise<void>;
        echo: import("./echo").EchoFunction;
        node: (module: string, ...args: any[]) => Promise<any>;
        run: (...commandLine: any[]) => import("./command").ProcessPipePromise;
        interactive: (...commandLine: any[]) => import("./command").ProcessPipePromise;
    };
    absolutelySilently: {
        fail: (...args: any[]) => never;
        cp: (from: string, to: string) => Promise<void>;
        mv: (from: string, to: string) => Promise<void>;
        rm: (file: string) => Promise<void>;
        exists: (file: string) => Promise<boolean>;
        touch: (file: string) => Promise<void>;
        mkdir: (d: string) => Promise<void>;
        chmod: (file: string, mode: string | number) => Promise<void>;
        echo: import("./echo").EchoFunction;
        node: (module: string, ...args: any[]) => Promise<any>;
        run: (...commandLine: any[]) => import("./command").ProcessPipePromise;
        interactive: (...commandLine: any[]) => import("./command").ProcessPipePromise;
    };
    cd: (into: string) => any;
    withEnv: (e: Dict<string>) => any;
    fail: (...args: any[]) => never;
    cp: (from: string, to: string) => Promise<void>;
    mv: (from: string, to: string) => Promise<void>;
    rm: (file: string) => Promise<void>;
    exists: (file: string) => Promise<boolean>;
    touch: (file: string) => Promise<void>;
    mkdir: (d: string) => Promise<void>;
    chmod: (file: string, mode: string | number) => Promise<void>;
    echo: import("./echo").EchoFunction;
    node: (module: string, ...args: any[]) => Promise<any>;
    run: (...commandLine: any[]) => import("./command").ProcessPipePromise;
    interactive: (...commandLine: any[]) => import("./command").ProcessPipePromise;
};
