"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.searchConfig = void 0;
const tslib_1 = require("tslib");
const fs = (0, tslib_1.__importStar)(require("fs-extra"));
const path = (0, tslib_1.__importStar)(require("path"));
async function searchConfig(argv, fn) {
    let workDir = argv.r, explicitRuleFile = argv.f;
    if (explicitRuleFile) {
        explicitRuleFile = require.resolve(path.resolve(explicitRuleFile));
        if (!fs.pathExistsSync(explicitRuleFile)) {
            throw new Error(`Rule file ${explicitRuleFile} does not exist.`);
        }
        return {
            cwd: workDir || path.dirname(explicitRuleFile),
            config: explicitRuleFile,
        };
    }
    if (!workDir)
        workDir = process.cwd();
    workDir = path.resolve(workDir);
    do {
        if (fs.pathExistsSync(path.join(workDir, fn))) {
            return {
                cwd: workDir,
                config: path.join(workDir, fn),
            };
        }
        if (path.resolve(workDir, "..") === workDir)
            break;
        workDir = path.resolve(workDir, "..");
    } while (true);
    throw new Error(`Rule file ${fn} does not exist.`);
}
exports.searchConfig = searchConfig;
