import { VerdaConfig } from "../config";
import Director from "../core/director";
export declare function bindDefaultRuleTypes(cfg: VerdaConfig, dir: Director): {
    SelfTracking: <T>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T, string[]>;
    phony: (<T_1>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_1, string[]>) => import("..").Goal<T_1, string[]>) & {
        glob: <T_2>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_2, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_2, string[]>;
        group: <T_3>(_subPrefix: string, FRecipe: import("..").ExportBuildRecipe<T_3, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_3, string[]>;
        make: <T_4, K extends string[]>(mk: (...args: K) => string, FRecipe: import("..").ExportBuildRecipe<T_4, string[]>) => (...args: K) => import("..").Goal<T_4, string[]>;
    };
    task: (<T_1>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_1, string[]>) => import("..").Goal<T_1, string[]>) & {
        glob: <T_2>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_2, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_2, string[]>;
        group: <T_3>(_subPrefix: string, FRecipe: import("..").ExportBuildRecipe<T_3, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_3, string[]>;
        make: <T_4, K extends string[]>(mk: (...args: K) => string, FRecipe: import("..").ExportBuildRecipe<T_4, string[]>) => (...args: K) => import("..").Goal<T_4, string[]>;
    };
    file: ((pattern: string, FRecipe: import("..").ExportBuildRecipe<void, import("./matchers").FileExecArgs>) => import("..").Goal<import("./interface").FileStatInfo, [import("..").ParsedPath, ...string[]]>) & {
        glob: (pattern: string, FRecipe: import("..").ExportBuildRecipe<void, import("./matchers").FileExecArgs>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<import("./interface").FileStatInfo, [import("..").ParsedPath, ...string[]]>;
        make: <K_1 extends string[]>(mk: (...args: K_1) => string, FRecipe: import("..").ExportBuildRecipe<void, import("./matchers").FileExecArgs>) => (...args: K_1) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
    };
    oracle: (<T_1>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_1, string[]>) => import("..").Goal<T_1, string[]>) & {
        glob: <T_2>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_2, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_2, string[]>;
        group: <T_3>(_subPrefix: string, FRecipe: import("..").ExportBuildRecipe<T_3, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_3, string[]>;
        make: <T_4, K extends string[]>(mk: (...args: K) => string, FRecipe: import("..").ExportBuildRecipe<T_4, string[]>) => (...args: K) => import("..").Goal<T_4, string[]>;
    };
    computed: (<T_1>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_1, string[]>) => import("..").Goal<T_1, string[]>) & {
        glob: <T_2>(pattern: string, FRecipe: import("..").ExportBuildRecipe<T_2, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_2, string[]>;
        group: <T_3>(_subPrefix: string, FRecipe: import("..").ExportBuildRecipe<T_3, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("..").Goal<T_3, string[]>;
        make: <T_4, K extends string[]>(mk: (...args: K) => string, FRecipe: import("..").ExportBuildRecipe<T_4, string[]>) => (...args: K) => import("..").Goal<T_4, string[]>;
    };
};
export declare function bindDefaultRulesAndFunctions(cfg: VerdaConfig, dir: Director): {
    rules: {
        F: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        S: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        D: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        fu: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        fileUpdated: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        sfu: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        sourceFileUpdated: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        ofu: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        optionalFileUpdated: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        fe: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        fileExists: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        de: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        dirExists: (literals: string | TemplateStringsArray, ...placeholders: string[]) => import("..").Goal<import("./interface").FileStatInfo, import("./matchers").FileExecArgs>;
        dc: import("..").GoalFunction<import("..").DirContents, string[]>;
        dirContent: import("..").GoalFunction<import("..").DirContents, string[]>;
        ds: import("..").GoalFunction<import("..").DirContents, string[]>;
        dirStructure: import("..").GoalFunction<import("..").DirContents, string[]>;
    };
    predefinedFuncs: {
        FileList: (options: import("../predefined-functions/file-list").FileListDefinitionOptions) => (target: import("..").BuildContext) => Promise<string[]>;
    };
};
