import Director from "../core/director";
import { ExportBuildRecipe, ExtBuildContext, GoalMatcher, PreBuildContext, PreBuildResult, Rule } from "../core/interface";
import { RuleBase } from "./rule-base";
declare type Args = string[];
export declare class OracleRule<T> extends RuleBase<Args> implements Rule<T, Args> {
    private isOracle;
    private FRecipe;
    readonly kindTag = "Mock::OracleRule";
    constructor(isOracle: boolean, matcher: GoalMatcher<Args>, FRecipe: ExportBuildRecipe<T, Args>);
    matchString(id: string): null;
    build(t: ExtBuildContext<T>, ...args: Args): Promise<T>;
    preBuild(t: PreBuildContext<T>): Promise<PreBuildResult.NO | PreBuildResult.YES>;
    shouldTriggerModify(t: PreBuildContext<T>, itselfModified: boolean): Promise<boolean>;
}
export declare function Oracle(dir: Director): {
    oracle: (<T>(pattern: string, FRecipe: ExportBuildRecipe<T, string[]>) => import("../core/interface").Goal<T, string[]>) & {
        glob: <T_1>(pattern: string, FRecipe: ExportBuildRecipe<T_1, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("../core/interface").Goal<T_1, string[]>;
        group: <T_2>(_subPrefix: string, FRecipe: ExportBuildRecipe<T_2, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("../core/interface").Goal<T_2, string[]>;
        make: <T_3, K extends string[]>(mk: (...args: K) => string, FRecipe: ExportBuildRecipe<T_3, string[]>) => (...args: K) => import("../core/interface").Goal<T_3, string[]>;
    };
    computed: (<T>(pattern: string, FRecipe: ExportBuildRecipe<T, string[]>) => import("../core/interface").Goal<T, string[]>) & {
        glob: <T_1>(pattern: string, FRecipe: ExportBuildRecipe<T_1, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("../core/interface").Goal<T_1, string[]>;
        group: <T_2>(_subPrefix: string, FRecipe: ExportBuildRecipe<T_2, string[]>) => (literals: string | TemplateStringsArray, ...placeholders: unknown[]) => import("../core/interface").Goal<T_2, string[]>;
        make: <T_3, K extends string[]>(mk: (...args: K) => string, FRecipe: ExportBuildRecipe<T_3, string[]>) => (...args: K) => import("../core/interface").Goal<T_3, string[]>;
    };
};
export {};
